import calendar
calendar.setfirstweekday(6) #start day  Mon(0)-Sun(6)

from DateTime import DateTime

def calendar_getmonth(theyear, themonth):
    """ scraps the calendar modules output """
    _cal = {}
    _cal['month']=calendar.month_name[themonth]
    _cal['dayname_sequence']=calendar.weekheader(2).strip().split()
    _cal['weeks_by_days']=None #sequence of weeks by sequence of days
    _weeks=()

    for aweek in calendar.monthcalendar(theyear, themonth):
        l_days=()
        for x in range(3, 22, 3):
            l_days=l_days+(calendar.week(aweek, 2)[x-3:x].strip(), )
        _weeks=_weeks+(l_days,)

    _cal['weeks_by_days']=_weeks

    return _cal

def catalog_getevents(self, year='2002', month='1'):
    """ given a year and month return all the Event objects """
    month=str(month)
    year=str(year)
    first_day=DateTime(month+'/1/'+year)
    last_day=str(calendar.monthrange(int(year), int(month))[1])
    last_day=DateTime(month+'/'+last_day+'/'+year)
    results=()
    query=self.portal_catalog(Type='Event', start=(first_day, last_day), start_usage='range:min:max', sort_on='start')
    for result in query:
        results+=(result.getObject(), )
    return results

def getEventsForCalendar(self, month='1', year='2002'):
    """ recreates a sequence of weeks, by days each day is a mapping.
        {'day': #, 'url': None}
    """
    year=int(year)
    month=int(month)
    daysByWeek=calendar_getmonth(year, month)
    weeks=()
    
    events=list( catalog_getevents(self, year, month)[:] )
    event=None
    if events:
        event=events.pop(0)

    for week in daysByWeek['weeks_by_days']:
        days=()
        for day in week:
            try: day=int(day)
            except: day=0
            if event:
                if event.start().day()==day:
                    day = { 'day' : day
                          , 'url' : event.absolute_url() }
            if type(day)!=type({}): #lame
                if day==0: day=''
                day = { 'day' : day
                      , 'url' : None }            
            else:
                while events and (event.start().day()<=day):
                    event=events.pop(0)                
            days+=(day, )
        weeks+=(days, )
    return weeks
